]> asedeno.scripts.mit.edu Git - git.git/blob - git-sh-setup.sh
Move the pick_author code to git-sh-setup
[git.git] / git-sh-setup.sh
1 #!/bin/sh
2 #
3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
6 # it dies.
7
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be be taken to unexpected places.  If you
10 # like CDPATH, define it for your interactive shell sessions without
11 # exporting it.
12 unset CDPATH
13
14 die() {
15         echo >&2 "$@"
16         exit 1
17 }
18
19 usage() {
20         die "Usage: $0 $USAGE"
21 }
22
23 set_reflog_action() {
24         if [ -z "${GIT_REFLOG_ACTION:+set}" ]
25         then
26                 GIT_REFLOG_ACTION="$*"
27                 export GIT_REFLOG_ACTION
28         fi
29 }
30
31 is_bare_repository () {
32         git-config --bool --get core.bare ||
33         case "$GIT_DIR" in
34         .git | */.git) echo false ;;
35         *) echo true ;;
36         esac
37 }
38
39 cd_to_toplevel () {
40         cdup=$(git-rev-parse --show-cdup)
41         if test ! -z "$cdup"
42         then
43                 cd "$cdup" || {
44                         echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
45                         exit 1
46                 }
47         fi
48 }
49
50 require_work_tree () {
51         test $(is_bare_repository) = false &&
52         test $(git-rev-parse --is-inside-git-dir) = false ||
53         die "fatal: $0 cannot be used without a working tree."
54 }
55
56 get_author_ident_from_commit () {
57         pick_author_script='
58         /^author /{
59                 s/'\''/'\''\\'\'\''/g
60                 h
61                 s/^author \([^<]*\) <[^>]*> .*$/\1/
62                 s/'\''/'\''\'\'\''/g
63                 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
64
65                 g
66                 s/^author [^<]* <\([^>]*\)> .*$/\1/
67                 s/'\''/'\''\'\'\''/g
68                 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
69
70                 g
71                 s/^author [^<]* <[^>]*> \(.*\)$/\1/
72                 s/'\''/'\''\'\'\''/g
73                 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
74
75                 q
76         }
77         '
78         encoding=$(git config i18n.commitencoding || echo UTF-8)
79         git show -s --pretty=raw --encoding="$encoding" "$1" |
80         LANG=C LC_ALL=C sed -ne "$pick_author_script"
81 }
82
83 if [ -z "$LONG_USAGE" ]
84 then
85         LONG_USAGE="Usage: $0 $USAGE"
86 else
87         LONG_USAGE="Usage: $0 $USAGE
88
89 $LONG_USAGE"
90 fi
91
92 case "$1" in
93         -h|--h|--he|--hel|--help)
94         echo "$LONG_USAGE"
95         exit
96 esac
97
98 # Make sure we are in a valid repository of a vintage we understand.
99 if [ -z "$SUBDIRECTORY_OK" ]
100 then
101         : ${GIT_DIR=.git}
102         GIT_DIR=$(GIT_DIR="$GIT_DIR" git-rev-parse --git-dir) || {
103                 exit=$?
104                 echo >&2 "You need to run this command from the toplevel of the working tree."
105                 exit $exit
106         }
107 else
108         GIT_DIR=$(git-rev-parse --git-dir) || exit
109 fi
110 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}